'n shr v+n shl -v 'ror v%
'n shl v+n shr -v 'rol v%
'n shr 1+n shl (32-1) 'ror const
'version 2.8 by sinjin
'superstrict
appdir=addslash(convertchar(appdir,asc"/",asc"\"))
appfile=convertchar(appfile,asc"/",asc"\")

const key_esc%     =key_escape
const key_capslock%=20

rem
function printevent(ev:tevent=null)
  local s$=event2str(ev)
  if s then print s
endfunction
function event2str$(ev:tevent=null)
  if not ev then ev=currentevent
  local s$
  select ev.id
  case 0  return "NullEvent"
  case event_appsuspend      s="AppSuspend     "
  case event_appresume       s="AppResume      "
  case event_appterminate    s="AppTerminate   "
  case event_keydown         s="KeyDown        "
  case event_keyup           s="KeyUp          "
  case event_keychar         s="KeyChar        "
  case event_keyrepeat       s="KeyRepeat      "
  case event_mousedown       s="MouseDown      "
  case event_mouseup         s="MouseUp        "
  case event_mousemove       s="MouseMove      "
  case event_mousewheel      s="MouseWheel     "
  case event_mouseenter      s="MouseEnter     "
  case event_mouseleave      s="MouseLeave     "
  case event_timertick       s="TimerTick      "
  case event_hotkeyhit       s="HotKeyHit      "
  case event_menuaction      s="MenuAction     "
  case event_windowmove      s="WindowMove     "
  case event_windowsize      s="WindowSize     "
  case event_windowclose     s="WindowClose    "
  case event_windowactivate  s="WindowActivate "
  case event_windowaccept    s="WindowAccept   "
  case event_gadgetaction    s="GadgetAction   "
  case event_gadgetpaint     s="GadgetPaint    "
  case event_gadgetselect    s="GadgetSelect   "
  case event_gadgetmenu      s="GadgetMenu     "
  case event_gadgetopen      s="GadgetOpen     "
  case event_gadgetclose     s="GadgetClose    "
  case event_gadgetdone      s="GadgetDone     "
  case event_gadgetlostfocus s="GadgetLostFocus"
  case event_gadgetshape     s="GadgetShape    "
  case event_joybut          s="JoyBut         "
  case event_joymove         s="JoyMove        "
  default                    s="UnknownEvent   "
  endselect
  s:+",id:$"+delead(hex(ev.id),asc"0")..
  +", data:"+ev.data..
  +", mods:"+ev.mods..
  +", x:"+ev.x..
  +",y:"+ev.y..
  +", extra:"+string(ev.extra)..
  +", hnd:"+handlefromobject(ev.source)
  return s
endfunction
rem
endrem

function instrl%(src$,ch$,pos%=0)
  local cl%=ch.length
  if (cl=0) then return 0
  if (pos=0) then pos=src.length
  pos:-cl
  while (pos>=0)
    local p%
    while (p<cl)
      if (src[pos+p]<>ch[p]) then exit
      p:+1
    wend
    if (p=cl) then return pos+1
    pos:-1
  wend
endfunction

function convertchar$(src$,ch1%,ch2%)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=ch1) then src=src[..sl]+chr(ch2)+src[sl+1..]
  wend
  return src
endfunction

function convertstr$(src$,ch1$,ch2$)
  local cl1%=ch1.length
  if (cl1=0) then return src
  local pos%=src.length
  pos:-cl1
  while (pos>=0)
'    if (lower(src[pos..pos+cl1])=ch1) then src=src[..pos]+ch2+src[pos+cl1..]
    local b%
    while (b<cl1)
      if (src[pos+b]<>ch1[b]) then exit
      b:+1
    wend
    if (b=cl1) then src=src[..pos]+ch2+src[pos+cl1..]
    pos:-1
  wend
  return src
endfunction

function delead$(src$,ch%=asc" ")
  local a%,sl%=src.length
  while (a<sl) and (src[a]=ch)
    a:+1
  wend
  return src[a..]
endfunction
function delast$(src$,ch%=asc"\")
  local sl%=src.length-1
  while (sl>=0) and (src[sl]=ch)
    sl:-1
  wend
  return src[..sl+1]
endfunction
function deleast$(src$,ch%=asc" ")
  local a%,sl%=src.length
  while (a<sl) and (src[a]=ch)
    a:+1
  wend

  sl:-1
  while (sl>=0) and (src[sl]=ch)
    sl:-1
  wend
  return src[a..sl+1]
endfunction

function findcharpos%(src$,ch%,nr%=1)
  if (nr=0) then return 0
  local sl%
  while (sl<src.length)
    if (src[sl]=ch) then
      nr:-1
      if (nr=0) then return sl+1
    endif
    sl:+1
  wend
  return sl
endfunction

function charmul$(ch$,mul%)
  if not mul then return ""
  local a%=1
  while (a+a<mul)
    ch:+ch
    a:+a
  wend
  return ch+ch[..mul-a]
endfunction

function between$(src$,pos%=1,ch%=asc"\")
  local sl%
  local st%
  while (sl<src.length)
    if (src[sl]=ch) then
      pos:-1
      if (pos<=0) then return src[st..sl]'+1]
      st=sl+1
    endif
    sl:+1
  wend
'  if (pos=1) then return src[st..]
  return src[st..]
endfunction

function delchar$(src$,ch%)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=ch) then src=src[..sl]+src[sl+1..]
  wend
  return src
endfunction

function delchars$(src$,ch$="\/:*?<>|"+chr(34))
  local sl%=src.length,cl%=ch.length-1
  while (sl>0)
    sl:-1
    local a%=cl,sc%=src[sl]
    while (a>=0)
      if (sc=ch[a]) then exit
      a:-1
    wend
    if (a>=0) then src=src[..sl]+src[sl+1..]
  wend
  return src
endfunction

function zeroed$(src$,ch$="0",mul%)
'  mul:-src.length
'  return charmul(ch,mul)+src
  mul:-src.length
  if (mul<=0) then return src
  local a%=1
  while (a+a<mul)
    ch:+ch
    a:+a
  wend
  return ch+ch[..mul-a]+src
endfunction

'-------------------

incbin "ytbl.bin"
const maxytbl%=28

const aweek%=7
global days$[]=["So","Mo","Di","Mi","Do","Fr","Sa"]

const _hour%=0
const _min%=1
const _sec%=2
const _year%=0
const _mon%=1
const _day%=2

function datetime2str$(src%[],srcpos%=0)
  return zeroed(src[srcpos+3+_hour],"0",2)+":"..
        +zeroed(src[srcpos+3+_min] ,"0",2)+":"..
        +zeroed(src[srcpos+3+_sec] ,"0",2)+", "..
        +zeroed(src[srcpos+_day]   ,"0",2)+"."..
        +zeroed(src[srcpos+_mon]   ,"0",2)+"."..
        +src[srcpos+_year]
endfunction

function calcday%(src%[],srcpos%=0)
  return (byte ptr(incbinptr("ytbl.bin"))[src[srcpos+_year] mod maxytbl*12 + src[srcpos+_mon]-1] + src[srcpos+_day]-1) mod aweek
endfunction

'------------------------------------------

global desk%[4] 'x y w h
getdesktoparea desk

function createwline:tgadget(x%,y%,w%,grp:tgadget,hsz%=1,style%=label_sunkenframe)
  local g:tgadget=createlabel("",x,y,w,hsz+(style=label_frame),grp,style)
  setlayout g,x+w,y,grp
  return g
endfunction

function setlayout(g:tgadget,xw%,yh%,grp:tgadget,lft%=1,up%=1)
  local x2%,y2%
  if (xw=clientwidth (grp)) then x2=1
  if (yh=clientheight(grp)) then y2=1
'  if (xw=gadgetwidth (grp)) then x2=1
'  if (yh=gadgetheight(grp)) then y2=1
  setgadgetlayout g,lft,x2,up,y2
endfunction

function createlab:tgadget(name$,x%,y%,w%,h%,grp:tgadget,style%=0)
  local g:tgadget=createlabel(name,x,y,w,h,grp,style)
  setlayout g,x+w,y+h,grp
  return g
endfunction

const event_dropfile%=$4010
const event_dropdir%=$4011

'check load and save with clientcoords
function createwin:twin(name$,x%,y%,w%,h%,style%=15,grp:tgadget=null)
  local g:twin=new twin
  g.name=name
  g.x=x
  g.y=y
  g.w=w
  g.h=h
  g.maxsize
  g.outside
  g.hidden=(style&window_hidden>0)
  g.g=createwindow(name,x,y,w,h,grp,style)
'  if not(style&window_hidden) or (actwin=null) then actwin=g
'  g.client=(style&window_clientcoords<>0)
  g.cw=clientwidth (g.g)
  g.ch=clientheight(g.g)
'  g.cw=gadgetwidth (g.g)
'  g.ch=gadgetheight(g.g)
  return g
endfunction

type twin
  field g:tgadget
  field kid:tgadget=null
  field name$
  field x%,y%,w%,h%
  field cw%,ch%
  field dx%,dy%
  field hidden%',client%',maximized%
  field drop$,droptyp%

  method load(f:tstream,wh%=true,dat%=false)
    x=readpint(f)
    y=readpint(f)
    if wh then
      w=readpint(f)
      h=readpint(f)
    endif
'    client=readbyte(f)
    maxsize
    outside
    if not dat then return
    name=readstr(f)
    setgadgettext g,name
  endmethod
  method save(f:tstream,wh%=true,dat%=false)
    writepint f,x
    writepint f,y
    if wh then
      writepint f,w
      writepint f,h
    endif
'    writebyte f,client
    if not dat then return
    writestr f,name
  endmethod

  method setname(n$)
    name=n
    setgadgettext g,n
  endmethod

  method reset()
'    if client then setgadgetshape g,x+cclientwidth,y+cclientheight,w-cclientwidth,h-cclientheight..
'              else setgadgetshape g,x,y,w,h
    setgadgetshape g,x,y,w,h
    cw=clientwidth (g)
    ch=clientheight(g)
  endmethod

  method activate()
    if (kid=null) then activategadget g else activategadget kid
  endmethod

  method show()
    hidden=0
    showgadget g
    if (kid<>null) then activategadget kid
'    pollsystem
  endmethod
  method hide()
    hidden=1
    hidegadget g
    pollsystem
  endmethod

  method center()
    x=desk[0]+(desk[2]-w)/2
    y=desk[1]+(desk[3]-h)/2
  endmethod

  method maxsize()
    if (w>desk[2]) then w=desk[2]
    if (h>desk[3]) then h=desk[3]
  endmethod

  method inside()
    if (x+w>desk[0]+desk[2]) then x=desk[0]+desk[2]-w
    if (x<desk[0])           then x=desk[0]
    if (y+h>desk[1]+desk[3]) then y=desk[1]+desk[3]-h
    if (y<desk[1])           then y=desk[1]
  endmethod

  method outside()
    if (x+w<desk[0]+16) then x=desk[0]+16-w
    if (x>desk[2]-16)   then x=desk[2]-16
    if (y<desk[1]-10)   then y=desk[1]-10
    if (y>desk[3]-20)   then y=desk[3]-20
  endmethod

  method upd%() 'return currentevent.id
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_windowmove
      dx=currentevent.x-x
      dy=currentevent.y-y
      x=currentevent.x
      y=currentevent.y
      cw=clientwidth (g)
      ch=clientheight(g)
    case event_windowsize
      w=currentevent.x
      h=currentevent.y
      cw=clientwidth (g)
      ch=clientheight(g)
'    case event_windowactivate
'      actwin=self
'      if (kid<>null) then activategadget kid
    case event_windowaccept
      drop=string(currentevent.extra)
      droptyp=filetype(drop)
      if (droptyp=filetype_file) then
        drop=delast(drop)
        return event_dropfile
      endif
      return event_dropdir
    endselect
    return currentevent.id
  endmethod
endtype

'-----------------------------------------

type tbut
  field g:tgadget[]
  field flag%[] 'bit0=checkbox bit1=disabled bit2>=tag

  method load(f:tstream)
    for local a%=0 until readpint(f)
      local flg%=readpint(f)
      for local b%=0 until g.length
        if (flg shr 2=flag[b] shr 2) then setbuttonstate g[b],flg&1
      next
    next
  endmethod
  method save(f:tstream)
    local l%
    for local a%=0 until g.length
      if (flag[a]&1) then l:+1
    next
    writepint f,l
    for local a%=0 until g.length
      if (flag[a]&1) then writepint f,buttonstate(g[a])+(flag[a]&$fffffffc)
    next
  endmethod

  method sethidden(tg%,hide%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        if hide then hidegadget g[a] else showgadget g[a]
        return
      endif
    next
  endmethod

  method setstate(tg%,disable%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        flag[a]=(flag[a]&~2)+disable shl 1
        if disable then disablegadget g[a] else enablegadget g[a]
        return
      endif
    next
  endmethod

  method add(label$,tg%,x%,y%,w%,h%,grp:tgadget,sel%=0,style%=button_push,disable%=false)
    g=g[..g.length+1]
    g[g.length-1]=createbutton(label,x,y,w,h,grp,style)
    setlayout g[g.length-1],x+w,y+h,grp
    if sel then setbuttonstate g[g.length-1],1
    flag=flag[..flag.length+1]
    flag[flag.length-1]=((style=button_checkbox) or (style=button_radio))+(disable shl 1)+(tg shl 2)
    if disable then disablegadget g[g.length-1]
  endmethod

  method remove(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        freegadget g[a]
        for local b%=a until g.length-1
          g[b]=g[b+1]
          flag[b]=flag[b+1]
        next
        g=g[..g.length-1]
        flag=flag[..flag.length-1]
        return
      endif
    next
  endmethod

  method setname(tg%,name$)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then setgadgettext g[a],name
    next
  endmethod

  method get%(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then return buttonstate(g[a])
    next
  endmethod
  method set(tg%,sel%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then
        setbuttonstate g[a],sel
        return
      endif
    next
  endmethod

  method find%(tg%)
    for local a%=0 until g.length
      if (tg=flag[a] shr 2) then return a
    next
  endmethod

  method upd%() 'return tag
    if (currentevent.id<>event_gadgetaction) then return 0
    for local a%=0 until g.length
      if (currentevent.source=g[a]) then return flag[a] shr 2
    next
  endmethod
endtype

'-----------------------------------------

function createtab:ttab(x%,y%,w%,h%,grp:tgadget)
  local t:ttab=new ttab
  t.g=createtabber(x,y,w,h,grp)
  setlayout t.g,x+w,y+h,grp
  t.cw=clientwidth (t.g)
  t.ch=clientheight(t.g)
  return t
endfunction

type ttab
  field g:tgadget
  field t:tgadget[][]
  field cw%,ch%
  field on%,last%=-1,count%

  method load(f:tstream)
    activate min(readbyte(f),count-1)
  endmethod
  method save(f:tstream)
    writebyte f,on
  endmethod

  method activate(nr%=-1)
    if not t then return
    last=on
    if (nr>=0) then if (nr>=t.length) then on=t.length-1 else on=nr
    for local a1%=0 until t.length
      for local a2%=0 until t[a1].length
        if (t[a1][a2]<>null) then hidegadget t[a1][a2]
      next
    next
    for local a2%=0 until t[on].length
      if (t[on][a2]<>null) then showgadget t[on][a2]
    next
    selectgadgetitem g,on
    if t[on] then activategadget t[on][0]
  endmethod

  method clear()
    for local a%=0 until count
      for local b%=0 until t[a].length
        freegadget t[a][b]
      next
    next
    cleargadgetitems g
    t=t[..0]
    count=0
  endmethod

  method add(text$,tip$="")
    addgadgetitem g,text,,,tip
    count:+1
    t=t[..count]
  endmethod
  method remove(nr%=-1)
    if not t then return
    last=on
    if (nr>=0) then if (nr>=t.length) then on=t.length-1 else on=nr
    removegadgetitem g,on

    for local a%=0 until t[on].length
      freegadget t[on][a]
    next

    count:-1
    for local a%=on until count
      t[a]=t[a+1]
    next
    t=t[..count]
    if (on>=t.length) then on=t.length-1
    activate
  endmethod

  method addkid(tab%,kid:tgadget)
    if kid then hidegadget kid
    t[tab]=t[tab][..t[tab].length+1]
    t[tab][t[tab].length-1]=kid
  endmethod

  method upd%() 'return 1
    if (currentevent.source<>g)..
    or (currentevent.id<>event_gadgetaction) then return 0
    activate currentevent.data
    return 1
  endmethod
endtype

'-----------------------------------------

'~r ~n = new line(chr $10)
'~q    = "
'~~    = ~
'~t    = tab
'~0    = cut all behind

function createtext:ttext(x%,y%,w%,h%,grp:tgadget,style%=0)
  local t:ttext=new ttext
  t.flag=(style=textarea_readonly) shl 1
  t.g=createtextarea(x,y,w,h,grp,style)
  setlayout t.g,x+w,y+h,grp
'  setgadgetfilter t.g,textfilter
  settextareacolor t.g,0,0,0,true
  settextareacolor t.g,255,255,255,false
'  formattextareatext t.g,255,255,255,0
  t.settabs 3
  return t
endfunction

function freetext(t:ttext)
  freegadget t.g
endfunction

function textfilter%(ev:tevent,context:object)
  select ev.id
  case event_keydown,event_keychar
    if (ev.mods&modifier_command) then return 1
    if not ev.mods or (ev.mods&modifier_shift) then
      select ev.data
      case key_left,key_right,key_down,key_up,key_pageup,key_pagedown..
      ,key_delete,key_backspace,key_home,key_end,key_esc,key_capslock return 1
      endselect
    endif
    if (ev.mods&(modifier_shift)) then
      select ev.data
      case key_insert  return 1
      endselect
    endif
  endselect
  postevent ev
endfunction
'function textfilter2%(ev:tevent,contxt:object)
'  postevent ev
'endfunction

'select ttext.upd
'  case 1 tmenu.popup 0,win.g
'  case 2 ttext.updkey
type ttext
  field g:tgadget
  field tab%,flag% '$1=linesafe $2=readonly $4=insertmode
  field chars%,lines%
  field char%,line%,linestart%,lineend%,inline%
  field selchars%,sellines%
field lastcol%[3]'=[-1,-1,-1]
field lt$

  method load(f:tstream,data%=false)
    tab=readbyte(f)
    flag=readbyte(f)
    if not data then return
    settextareatext g,readstr(f)
    selecttextareatext g,readpint(f),readpint(f)
    updpos
  endmethod
  method save(f:tstream,data%=false)
    writebyte f,tab
    writebyte f,flag
    if not data then return
    writestr f,textareatext(g)
    writepint f,selchars
    writepint f,char
  endmethod

  method loadtxt(f:tstream,ln%=-1)
    while ln and not eof(f)
      addtextareatext g,readline(f)
      ln:-1
    wend
    updpos
  endmethod

  method importtxt(f:tstream)
    local t$=readstring(f,f.size()-f.pos())
    t=convertstr(t,chr(13)+"~n","~n")
    settextareatext g,t
    updpos
  endmethod
  method exporttxt(f:tstream)
    local t$=textareatext(g)
    t=convertstr(t,"~n",chr(13)+"~n")
    writestring f,t
  endmethod

  method settabs(sz%)
    tab=sz
    settextareatabs g,sz
  endmethod

  method lock(hid%=0)
    locktextarea g
    showmouse
    if hid then hidegadget g
  endmethod
  method unlock(shw%=0)
    unlocktextarea g
    if shw then showgadget g
  endmethod

  method setfont(fnt:tguifont,locked%=true)
'    updpos
    if locked then lock
    local t$=textareatext(g)
    settextareatext g,""
    settextareafont g,fnt
    settextareatext g,t
    selecttextareatext g,char,selchars
    if locked then unlock
  endmethod

  method searchr%(s$,sl%=true)
'    s=lower(s)
    if (selchars=s.length) and (lower(textareatext(g,char,selchars))=s) then char:+s.length
    local p%=instr(lower(textareatext(g,char)),s)
    if (p=0) then
      p=instr(lower(textareatext(g,0,char+s.length-1)),s)
      if (p=0) then return 0
      char=0
    endif
    char:+p-1
    selchars=s.length
    if sl then selecttextareatext g,char,selchars
    return 1
  endmethod
  method searchl%(s$,sl%=true)
'    s=lower(s)
    local p%=instrl(lower(textareatext(g,0,char+s.length-1)),s)
    if (p=0) then
      p=instrl(lower(textareatext(g,char)),s)
      if (p=0) then return 0
      char:+p-1
    else
      char=p-1
    endif
    selchars=s.length
    if sl then selecttextareatext g,char,selchars
    return 1
  endmethod

  method getline$(l%=-1)
    if (l<0) then l=line
    return delast(textareatext(g,l,1,textarea_lines),10)
  endmethod
  method insline(t$,l%=-1)
    if (l<0) then l=line
    settextareatext g,addslash(t,10),l,0,textarea_lines
    updpos
  endmethod
  method delline(l%=-1,complete%=true)
    if (l<0) then l=line
    local c%=textareachar(g,l)
    settextareatext g,"",c,textareachar(g,l+1)-c-1+complete
    updpos
  endmethod

  method set(t$)
    settextareatext g,t
    updpos
  endmethod
  method insert(t$,sel0%=false)
    settextareatext g,t,char,selchars
    if sel0 then
      selecttextareatext g,char,t.length
    else
      selecttextareatext g,char+t.length,0
    endif
    updpos
  endmethod

  method add(t$,col%[])
    addtextareatext g,t
    formattextareatext g,col[0],col[1],col[2],0,textarealen(g)-t.length,t.length
    updpos
  endmethod
  method add2start()
    lt=""
    lastcol=[-1,-1,-1]
  endmethod
  method add2(t$,col%[])
    if (col[0]<>lastcol[0]) or (col[1]<>lastcol[1]) or (col[2]<>lastcol[2]) then
      addtextareatext g,lt
      formattextareatext g,lastcol[0],lastcol[1],lastcol[2],0,textarealen(g)-lt.length,lt.length
      lastcol[0]=col[0]
      lastcol[1]=col[1]
      lastcol[2]=col[2]
      lt=""
    endif
    lt:+t
  endmethod
  method add2snapshot()
    addtextareatext g,lt
    formattextareatext g,lastcol[0],lastcol[1],lastcol[2],0,textarealen(g)-lt.length,lt.length
    lt=""
  endmethod
  method add2end()
    addtextareatext g,lt
    formattextareatext g,lastcol[0],lastcol[1],lastcol[2],0,textarealen(g)-lt.length,lt.length
    lt=""
    updpos
  endmethod

  method copypos(from:ttext)
    lineend=textareachar(g,from.line+1)'-(line<lines-1)
    char=min(lineend-(chars>lineend),textareachar(g,from.line)+from.inline)

    selchars=textareachar(g,from.line+from.sellines)-textareachar(g,from.line)..
     +min(textareachar(g,textarealine(g,char+selchars)+1)-textareachar(g,textarealine(g,char+selchars))..
         ,from.linestart+from.selchars-textareachar(from.g,textarealine(from.g,from.char+from.selchars)))

    selecttextareatext g,char,selchars
'    selecttextareatext g,char,min(lineend-char,from.selchars)
    updpos
  endmethod

  method updpos()
    local olines%=lines+(lines=0),oline%=line
    local a%
    repeat
      chars=textarealen(g)
      lines=textarealen(g,textarea_lines)+(chars>0)

      char=textareacursor(g)
      line=textareacursor(g,textarea_lines)
      linestart=textareachar(g,line)
      lineend=textareachar(g,line+1)'-(line<lines-1)
      inline=char-linestart

      selchars=textareasellen(g)
'      sellines=textareasellen(g,textarea_lines)-(inline<>0)*(selchars=0)
      sellines=textarealine(g,char+selchars)-line

      if not(flag&$1) or (lines=olines) or a then return
      a:+1
      locktextarea g
      if (lines>olines) then
        if (flag&$4) then
'          settextareatext g,"",textareachar(g,oline+1)-(oline=olines-1),textareachar(g,oline+1+lines-olines)-textareachar(g,oline+1)+(oline=olines-1)
          local lo%=lines-olines
          local olo%=oline+lo
          settextareatext g,"",textareachar(g,olo),textareachar(g,olo+lo)-textareachar(g,olo)
          settextareatext g,"",textareachar(g,olines)-(olines<textarealen(g,textarea_lines))
        else
          settextareatext g,"",textareachar(g,olines)-1
        endif
      else
        addtextareatext g,charmul(chr(10),olines-lines)
      endif
rem not working
      if (lines>olines) then
        settextareatext g,"",textareachar(g,oline+1),textareachar(g,lines-olines+oline+1)-textareachar(g,oline+1)..
        for local a%=lines-olines-1 to 0 step-1
          settextareatext g,"",textareachar(g,oline+1+a)-1,1
        next
      else
        addtextareatext g,charmul(chr(10),olines-lines)
      endif
rem
endrem

      unlocktextarea g
      selecttextareatext g,char,0
    forever
  endmethod

  method upd%() 'return 1=gadgetmenu, 2=active
    if (currentevent.source<>g) then return 0
    select currentevent.id
    case event_gadgetmenu  return 1
    case event_gadgetselect  updpos
    case event_gadgetlostfocus  return 0
    endselect
    return 2
  endmethod

  method updkey()
    select currentevent.id
    case event_keydown
      select currentevent.data
      case key_insert  flag:~$4
      endselect

    case event_keychar
      settextareatext g,chr(currentevent.data),char,selchars+(flag&$4<>0)
      selecttextareatext g,char+1,0
      updpos
'      return true
    endselect
  endmethod

  method pos2str$()
    return "chs:"+chars+" lns:"+lines..
     +" ch:"+char+" ln:"+line+" ls:"+linestart+" le:"+lineend+" inl:"+inline..
     +" selchs:"+selchars+" sellns:"+sellines
  endmethod
endtype

'-----------------------------------------

'style=$1=textfield_password $2=disable
function createfeld:tfeld(text$,x%,y%,w%,h%,grp:tgadget,style%=0)
  local f:tfeld=new tfeld
  f.g=createtextfield(x,y,w,h,grp,style&1)
  setgadgetcolor f.g,0,0,0
  setgadgettextcolor f.g,255,255,255
  setlayout f.g,x+w,y+h,grp
  setgadgettext f.g,text
  f.state=(style&2) shr 1
  if f.state then disablegadget f.g
  return f
endfunction

type tfeld
  field g:tgadget
  field state% '$1=disabled

  method load(f:tstream)
    setgadgettext g,readstr(f)
  endmethod
  method save(f:tstream)
    writestr f,textfieldtext(g)
  endmethod

  method setstate(disable%)
    state=disable
    if disable then disablegadget g else enablegadget g
  endmethod

  method get$()
    return textfieldtext(g)
  endmethod
  method set(s$)
    setgadgettext g,s
  endmethod

  method upd%()
    if (currentevent.id<>event_gadgetaction)..
    or (currentevent.source<>g) then return 0
    return 1
  endmethod
endtype

'-----------------------------------------

function gotohead%(f:tstream,what$,seek0%=true)
  if seek0 then f.seek 0
  what=lower(what)
  while not eof(f)
    local t$=deleast(readcomment(f))
    if t and (t[0]=asc"[") and (t[t.length-1]=asc"]")..
    and (lower(deleast(delchars(t,"[]")))=what) then return true
'    and (lower(deleast(t[1..t.length-2]))=what) then return true
  wend
endfunction

function readcomment$(f:tstream,linecom%=asc";")
  local t$
  while not eof(f)
    t=readline(f)
    if not t then continue
    local a%
    while (a<t.length)
      if (t[a]<>asc" ") then exit
      a:+1
    wend
    if (a<t.length) and (t[a]=linecom) then continue
    return t
  wend
endfunction

function getlr(l$ var,r$ var,s$="=")
  local i%=instr(l,s)
  if not i then return
  r=deleast(l[i+s.length-1..])
  l=deleast(l[..i-1])
endfunction

function readpint%(f:tstream)
  local ret%,a%,c%
  repeat
    a=readbyte(f)
    ret:+(a&$7f) shl c
    c:+7
  until not(a&$80)
  return ret
endfunction
function writepint(f:tstream,src%)
  repeat
    writebyte f,(src&$7f) + ((src shr 7<>0) shl 7)
    src:shr 7
  until not src
endfunction

function readstr$(f:tstream)
  return readstring(f,readpint(f))
endfunction
function writestr(f:tstream,s$)
  writepint f,s.length
  writestring f,s
endfunction

function addslash$(src$,sl%=asc"\")
  if src.length and (src[src.length-1]<>sl) then return src+chr(sl)
  return src
endfunction

'c:\path1.a\path2.b\file.test = c:\path1.a\path2.b\
function trimpath$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[..sl+1]
  wend
  return src[..sl]
endfunction

'c:\path1.a\path2.b\file.test = file
function trimname$(src$,hidext%=false)
  local sl1%=src.length
  local sl2%=sl1
  local l%=true
  while (sl1>0)
    sl1:-1
    if (l or hidext) and (src[sl1]=asc".") then
      sl2=sl1
      l=false
    endif
    if (src[sl1]=asc"\") then return src[sl1+1..sl2]
  wend
  return src[sl1..sl2]
endfunction

'c:\path1.a\path2.b\file.test = c:\path1.a\path2.b\file
function trimpname$(src$,hidext%=false)
  local sl%=src.length
  local sl2%=src.length
  local l%=true
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[..sl2]
'    if (src[sl]=asc".") then return src[..sl]
    if (l or hidext) and (src[sl]=asc".") then
      sl2=sl
      l=false
    endif
  wend
  return src[..sl2]
endfunction

'c:\path1.a\path2.b\file.test = file.test
function trimfile$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc"\") then return src[sl+1..]
  wend
  return src
endfunction

'c:\path1.a\path2.b\file.test = test
function trimext$(src$)
  local sl%=src.length
  while (sl>0)
    sl:-1
    if (src[sl]=asc".") then return src[sl+1..]
    if (src[sl]=asc"\") then return ""
  wend
endfunction

'-----------------------------------------

extern "Win32"
  function SystemParametersInfoA%(action%,param%,param2:byte ptr,winini%)
  function GetLocalTime(apitime:byte ptr)
endextern

function getdesktoparea(lpRect%[]) 'x y w h
  SystemParametersInfoA(SPI_GETWORKAREA,0,lpRect,0)
endfunction

private
type tapitime
  field Year:short
  field Month:short
  field DayOfWeek:short
  field Day:short
  field Hour:short
  field Minute:short
  field Second:short
  field Milliseconds:short
endtype
public
function getdatetime(dst%[])
  local ap:tapitime=new tapitime
  getlocaltime ap
  dst[_year]=ap.year
  dst[_mon]=ap.month
  dst[_day]=ap.day
  dst[3+_hour]=ap.hour
  dst[3+_min]=ap.minute
  dst[3+_sec]=ap.second
endfunction

'-----------------------------------------
